(function (_, kotlin_kotlin, kotlin_org_jetbrains_kotlinx_kotlinx_datetime) {
  'use strict';
  //region block: imports
  var imul = Math.imul;
  var protoOf = kotlin_kotlin.$_$.j8;
  var getStringHashCode = kotlin_kotlin.$_$.m7;
  var hashCode = kotlin_kotlin.$_$.n7;
  var THROW_CCE = kotlin_kotlin.$_$.tb;
  var equals = kotlin_kotlin.$_$.h7;
  var classMeta = kotlin_kotlin.$_$.f7;
  var setMetadataFor = kotlin_kotlin.$_$.k8;
  var split = kotlin_kotlin.$_$.ra;
  var ArrayList_init_$Create$ = kotlin_kotlin.$_$.l;
  var charSequenceLength = kotlin_kotlin.$_$.d7;
  var Unit_instance = kotlin_kotlin.$_$.f3;
  var collectionSizeOrDefault = kotlin_kotlin.$_$.c4;
  var ArrayList_init_$Create$_0 = kotlin_kotlin.$_$.k;
  var Companion_getInstance = kotlin_org_jetbrains_kotlinx_kotlinx_datetime.$_$.b;
  var joinToString = kotlin_kotlin.$_$.v4;
  var listOf = kotlin_kotlin.$_$.f5;
  var isCharSequence = kotlin_kotlin.$_$.t7;
  var trim = kotlin_kotlin.$_$.eb;
  var toString = kotlin_kotlin.$_$.m8;
  var reversed = kotlin_kotlin.$_$.t5;
  var last = kotlin_kotlin.$_$.b5;
  var emptyList = kotlin_kotlin.$_$.k4;
  var listOf_0 = kotlin_kotlin.$_$.e5;
  var plus = kotlin_kotlin.$_$.p5;
  var VOID = kotlin_kotlin.$_$.g;
  var first = kotlin_kotlin.$_$.o4;
  var copyToArray = kotlin_kotlin.$_$.h4;
  var to = kotlin_kotlin.$_$.rc;
  var json = kotlin_kotlin.$_$.b8;
  //endregion
  //region block: pre-declaration
  setMetadataFor(CommitRef, 'CommitRef', classMeta);
  setMetadataFor(GitAdapter, 'GitAdapter', classMeta);
  setMetadataFor(TagRef, 'TagRef', classMeta);
  //endregion
  function CommitRef(id, authorEmail, committerEmail, dateTime, parents, fullMessage) {
    this.o18_1 = id;
    this.p18_1 = authorEmail;
    this.q18_1 = committerEmail;
    this.r18_1 = dateTime;
    this.s18_1 = parents;
    this.t18_1 = fullMessage;
  }
  protoOf(CommitRef).toString = function () {
    return 'CommitRef(id=' + this.o18_1 + ', authorEmail=' + this.p18_1 + ', committerEmail=' + this.q18_1 + ', dateTime=' + this.r18_1 + ', parents=' + this.s18_1 + ', fullMessage=' + this.t18_1 + ')';
  };
  protoOf(CommitRef).hashCode = function () {
    var result = getStringHashCode(this.o18_1);
    result = imul(result, 31) + getStringHashCode(this.p18_1) | 0;
    result = imul(result, 31) + getStringHashCode(this.q18_1) | 0;
    result = imul(result, 31) + this.r18_1.hashCode() | 0;
    result = imul(result, 31) + hashCode(this.s18_1) | 0;
    result = imul(result, 31) + getStringHashCode(this.t18_1) | 0;
    return result;
  };
  protoOf(CommitRef).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof CommitRef))
      return false;
    var tmp0_other_with_cast = other instanceof CommitRef ? other : THROW_CCE();
    if (!(this.o18_1 === tmp0_other_with_cast.o18_1))
      return false;
    if (!(this.p18_1 === tmp0_other_with_cast.p18_1))
      return false;
    if (!(this.q18_1 === tmp0_other_with_cast.q18_1))
      return false;
    if (!this.r18_1.equals(tmp0_other_with_cast.r18_1))
      return false;
    if (!equals(this.s18_1, tmp0_other_with_cast.s18_1))
      return false;
    if (!(this.t18_1 === tmp0_other_with_cast.t18_1))
      return false;
    return true;
  };
  function parseLog($this, outputText) {
    // Inline function 'kotlin.collections.map' call
    // Inline function 'kotlin.collections.filter' call
    // Inline function 'kotlin.collections.filterTo' call
    var this_0 = split(outputText, [$this.v18_1 + '\n']);
    var destination = ArrayList_init_$Create$();
    var tmp0_iterator = this_0.m();
    while (tmp0_iterator.n()) {
      var element = tmp0_iterator.o();
      // Inline function 'com.zegreatrob.tools.adapter.git.GitAdapter.parseLog.<anonymous>' call
      // Inline function 'kotlin.text.isNotEmpty' call
      if (charSequenceLength(element) > 0) {
        destination.e(element);
      }
    }
    // Inline function 'kotlin.collections.mapTo' call
    var destination_0 = ArrayList_init_$Create$_0(collectionSizeOrDefault(destination, 10));
    var tmp0_iterator_0 = destination.m();
    while (tmp0_iterator_0.n()) {
      var item = tmp0_iterator_0.o();
      // Inline function 'com.zegreatrob.tools.adapter.git.GitAdapter.parseLog.<anonymous>' call
      var elements = split(item, ['\n']);
      var tmp = elements.q(0);
      var tmp_0 = elements.q(1);
      var tmp_1 = elements.q(2);
      var tmp_2 = Companion_getInstance().r17(elements.q(3));
      // Inline function 'kotlin.collections.filter' call
      // Inline function 'kotlin.collections.filterTo' call
      var this_1 = split(elements.q(4), [' ']);
      var destination_1 = ArrayList_init_$Create$();
      var tmp0_iterator_1 = this_1.m();
      while (tmp0_iterator_1.n()) {
        var element_0 = tmp0_iterator_1.o();
        // Inline function 'com.zegreatrob.tools.adapter.git.GitAdapter.parseLog.<anonymous>.<anonymous>' call
        // Inline function 'kotlin.text.isNotEmpty' call
        if (charSequenceLength(element_0) > 0) {
          destination_1.e(element_0);
        }
      }
      var tmp$ret$8 = new CommitRef(tmp, tmp_0, tmp_1, tmp_2, destination_1, joinToString(elements.t1(5, elements.p()), '\n'));
      destination_0.e(tmp$ret$8);
    }
    return destination_0;
  }
  function GitAdapter(workingDirectory) {
    this.u18_1 = workingDirectory;
    this.v18_1 = '--------!--------';
    this.w18_1 = '%H%n%ae%n%ce%n%aI%n%P%n%B%n' + this.v18_1;
  }
  protoOf(GitAdapter).x18 = function () {
    // Inline function 'kotlin.text.trim' call
    var this_0 = runProcess(listOf(['git', '--no-pager', 'rev-parse', 'HEAD']), this.u18_1);
    return toString(trim(isCharSequence(this_0) ? this_0 : THROW_CCE()));
  };
  protoOf(GitAdapter).y18 = function () {
    var outputText = runProcess(listOf(['git', '--no-pager', 'tag', '--list', '--sort=-taggerdate', '--format=%(refname:strip=2),%(*objectname),%(creatordate:iso-strict)']), this.u18_1);
    // Inline function 'kotlin.collections.mapNotNull' call
    // Inline function 'kotlin.collections.mapNotNullTo' call
    var this_0 = split(outputText, ['\n']);
    var destination = ArrayList_init_$Create$();
    // Inline function 'kotlin.collections.forEach' call
    var tmp0_iterator = this_0.m();
    while (tmp0_iterator.n()) {
      var element = tmp0_iterator.o();
      // Inline function 'kotlin.collections.mapNotNullTo.<anonymous>' call
      // Inline function 'com.zegreatrob.tools.adapter.git.GitAdapter.listTags.<anonymous>' call
      var commaSplit = split(element, [',']);
      var tmp;
      if (commaSplit.p() >= 3) {
        tmp = new TagRef(joinToString(commaSplit.t1(0, commaSplit.p() - 2 | 0), ''), reversed(commaSplit).q(1), Companion_getInstance().r17(last(commaSplit)));
      } else {
        tmp = null;
      }
      var tmp0_safe_receiver = tmp;
      if (tmp0_safe_receiver == null)
        null;
      else {
        // Inline function 'kotlin.let' call
        // Inline function 'kotlin.contracts.contract' call
        destination.e(tmp0_safe_receiver);
      }
    }
    var output = destination;
    return output;
  };
  protoOf(GitAdapter).z18 = function () {
    return parseLog(this, runProcess(listOf(['git', '--no-pager', 'log', '--format=' + this.w18_1]), this.u18_1));
  };
  protoOf(GitAdapter).a19 = function (begin, end) {
    return parseLog(this, runProcess(plus(listOf(['git', '--no-pager', 'log', '--format=' + this.w18_1, begin]), !(end == null) ? listOf_0(end) : emptyList()), this.u18_1));
  };
  protoOf(GitAdapter).b19 = function (begin, end, $super) {
    end = end === VOID ? null : end;
    return $super === VOID ? this.a19(begin, end) : $super.a19.call(this, begin, end);
  };
  function TagRef(name, commitId, dateTime) {
    this.c19_1 = name;
    this.d19_1 = commitId;
    this.e19_1 = dateTime;
  }
  protoOf(TagRef).toString = function () {
    return 'TagRef(name=' + this.c19_1 + ', commitId=' + this.d19_1 + ', dateTime=' + this.e19_1 + ')';
  };
  protoOf(TagRef).hashCode = function () {
    var result = getStringHashCode(this.c19_1);
    result = imul(result, 31) + getStringHashCode(this.d19_1) | 0;
    result = imul(result, 31) + this.e19_1.hashCode() | 0;
    return result;
  };
  protoOf(TagRef).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof TagRef))
      return false;
    var tmp0_other_with_cast = other instanceof TagRef ? other : THROW_CCE();
    if (!(this.c19_1 === tmp0_other_with_cast.c19_1))
      return false;
    if (!(this.d19_1 === tmp0_other_with_cast.d19_1))
      return false;
    if (!this.e19_1.equals(tmp0_other_with_cast.e19_1))
      return false;
    return true;
  };
  function get_childProcess() {
    _init_properties_RunProcess_js_kt__6db8dd();
    return childProcess;
  }
  var childProcess;
  function runProcess(args, workingDirectory) {
    _init_properties_RunProcess_js_kt__6db8dd();
    var program = first(args);
    // Inline function 'kotlin.collections.toTypedArray' call
    var this_0 = args.t1(1, args.p());
    var tmp$ret$0 = copyToArray(this_0);
    var spawn = get_childProcess().spawnSync(program, tmp$ret$0, json([to('cwd', workingDirectory), to('maxBuffer', 10485760)]));
    // Inline function 'kotlin.js.unsafeCast' call
    var tmp0_safe_receiver = spawn.stdout;
    return tmp0_safe_receiver == null ? null : tmp0_safe_receiver.toString('utf8');
  }
  var properties_initialized_RunProcess_js_kt_yehn37;
  function _init_properties_RunProcess_js_kt__6db8dd() {
    if (!properties_initialized_RunProcess_js_kt_yehn37) {
      properties_initialized_RunProcess_js_kt_yehn37 = true;
      childProcess = require('node:child_process');
    }
  }
  //region block: exports
  _.$_$ = _.$_$ || {};
  _.$_$.a = GitAdapter;
  //endregion
  return _;
}(module.exports, require('./kotlin-kotlin-stdlib.js'), require('./Kotlin-DateTime-library-kotlinx-datetime.js')));

//# sourceMappingURL=tools-git-adapter.js.map
