(function (_, kotlin_clikt_clikt, kotlin_kotlin, kotlin_mordant_mordant) {
  'use strict';
  //region block: imports
  var CoreCliktCommand = kotlin_clikt_clikt.$_$.a;
  var VOID = kotlin_kotlin.$_$.g;
  var Unit_instance = kotlin_kotlin.$_$.f3;
  var protoOf = kotlin_kotlin.$_$.j8;
  var classMeta = kotlin_kotlin.$_$.f7;
  var setMetadataFor = kotlin_kotlin.$_$.k8;
  var selfAndAncestors = kotlin_clikt_clikt.$_$.d;
  var mapNotNull = kotlin_kotlin.$_$.k9;
  var firstOrNull = kotlin_kotlin.$_$.f9;
  var Terminal_init_$Create$ = kotlin_mordant_mordant.$_$.g;
  var last = kotlin_kotlin.$_$.j9;
  var MultiplatformSystem_instance = kotlin_mordant_mordant.$_$.i;
  var FileNotFound = kotlin_clikt_clikt.$_$.b;
  var Terminal = kotlin_mordant_mordant.$_$.b;
  var Whitespace_NORMAL_getInstance = kotlin_mordant_mordant.$_$.e;
  var Text_init_$Create$ = kotlin_mordant_mordant.$_$.h;
  var AbstractHelpFormatter = kotlin_clikt_clikt.$_$.f;
  var verticalLayout = kotlin_mordant_mordant.$_$.a;
  var charSequenceLength = kotlin_kotlin.$_$.d7;
  var definitionList = kotlin_mordant_mordant.$_$.c;
  var withPadding = kotlin_mordant_mordant.$_$.d;
  var collectionSizeOrDefault = kotlin_kotlin.$_$.c4;
  var ArrayList_init_$Create$ = kotlin_kotlin.$_$.k;
  var ensureNotNull = kotlin_kotlin.$_$.ic;
  var drop = kotlin_kotlin.$_$.v9;
  var plus = kotlin_kotlin.$_$.oc;
  var Whitespace_PRE_WRAP_getInstance = kotlin_mordant_mordant.$_$.f;
  var isBlank = kotlin_kotlin.$_$.ca;
  var replace = kotlin_kotlin.$_$.oa;
  //endregion
  //region block: pre-declaration
  setMetadataFor(CliktCommand, 'CliktCommand', classMeta, CoreCliktCommand);
  setMetadataFor(MordantHelpFormatter, 'MordantHelpFormatter', classMeta, AbstractHelpFormatter);
  //endregion
  function CliktCommand(name) {
    name = name === VOID ? null : name;
    CoreCliktCommand.call(this, name);
    installMordant(this);
  }
  function installMordant(_this__u8e3s4, force) {
    force = force === VOID ? false : force;
    _this__u8e3s4.z1g(installMordant$lambda(force));
  }
  function get_terminal(_this__u8e3s4) {
    // Inline function 'com.github.ajalt.clikt.core.Context.findObject' call
    var key = 'mordant_terminal';
    var tmp = selfAndAncestors(_this__u8e3s4);
    var tmp0_elvis_lhs = firstOrNull(mapNotNull(tmp, _get_terminal_$lambda_5keric(key)));
    var tmp_0;
    if (tmp0_elvis_lhs == null) {
      // Inline function 'kotlin.also' call
      var this_0 = Terminal_init_$Create$();
      // Inline function 'kotlin.contracts.contract' call
      // Inline function 'com.github.ajalt.clikt.core.<get-terminal>.<anonymous>' call
      // Inline function 'kotlin.collections.set' call
      var this_1 = last(selfAndAncestors(_this__u8e3s4)).x1e_1;
      var key_0 = 'mordant_terminal';
      this_1.c2(key_0, this_0);
      tmp_0 = this_0;
    } else {
      tmp_0 = tmp0_elvis_lhs;
    }
    return tmp_0;
  }
  function installMordant$lambda$lambda(it) {
    return new MordantHelpFormatter(it);
  }
  function installMordant$lambda$lambda_0(it) {
    return MultiplatformSystem_instance.r22(it);
  }
  function installMordant$lambda$lambda_1(it) {
    var tmp0_elvis_lhs = MultiplatformSystem_instance.t22(it);
    var tmp;
    if (tmp0_elvis_lhs == null) {
      throw new FileNotFound(it);
    } else {
      tmp = tmp0_elvis_lhs;
    }
    return tmp;
  }
  function installMordant$lambda$lambda_2(it) {
    MultiplatformSystem_instance.s22(it);
    return Unit_instance;
  }
  function installMordant$lambda$lambda_3(context, message, trailingNewline, err) {
    if (trailingNewline) {
      get_terminal(context).r2c(message, VOID, VOID, VOID, VOID, err);
    } else {
      get_terminal(context).p2c(message, VOID, VOID, VOID, VOID, err);
    }
    return Unit_instance;
  }
  function installMordant$lambda($force) {
    return function ($this$configureContext) {
      var tmp;
      if (!$force ? !($this$configureContext.a1h_1 == null) : false) {
        return Unit_instance;
      }
      var tmp_0 = $this$configureContext;
      tmp_0.f1h_1 = installMordant$lambda$lambda;
      var tmp_1 = $this$configureContext;
      tmp_1.n1h_1 = installMordant$lambda$lambda_0;
      var tmp_2 = $this$configureContext;
      tmp_2.i1h_1 = installMordant$lambda$lambda_1;
      var tmp_3 = $this$configureContext;
      tmp_3.q1h_1 = installMordant$lambda$lambda_2;
      var tmp_4 = $this$configureContext;
      tmp_4.p1h_1 = installMordant$lambda$lambda_3;
      return Unit_instance;
    };
  }
  function _get_terminal_$lambda_5keric($key) {
    return function (it) {
      var tmp = it.x1e_1.v1($key);
      return tmp instanceof Terminal ? tmp : null;
    };
  }
  function MordantHelpFormatter$formatHelp$lambda(this$0, $error, $prolog, $epilog, $parameters, $programName) {
    return function ($this$verticalLayout) {
      $this$verticalLayout.h29(1);
      $this$verticalLayout.e29(this$0.g1n($error, $prolog, $epilog, $parameters, $programName));
      return Unit_instance;
    };
  }
  function MordantHelpFormatter$renderUsage$lambda($prog, $usageParts) {
    return function ($this$definitionList) {
      $this$definitionList.b2d($prog, Text_init_$Create$($usageParts, Whitespace_NORMAL_getInstance()));
      $this$definitionList.v2c_1 = true;
      $this$definitionList.y2c(1);
      return Unit_instance;
    };
  }
  function MordantHelpFormatter$renderProlog$lambda($this$withPadding) {
    $this$withPadding.e2b_1 = 2;
    return Unit_instance;
  }
  function MordantHelpFormatter$renderParameters$lambda(this$0, $parameters) {
    return function ($this$definitionList) {
      var _iterator__ex2g4s = this$0.t1o($parameters).m();
      while (_iterator__ex2g4s.n()) {
        var section = _iterator__ex2g4s.o();
        $this$definitionList.b2d(section.n1m_1, section.o1m_1);
      }
      return Unit_instance;
    };
  }
  function MordantHelpFormatter$renderOptionGroup$lambda($this$withPadding) {
    $this$withPadding.b2b_1 = 1;
    $this$withPadding.e2b_1 = 2;
    $this$withPadding.d2b_1 = 1;
    return Unit_instance;
  }
  function MordantHelpFormatter$renderOptionGroup$lambda_0($markdown, this$0, $options) {
    return function ($this$verticalLayout) {
      $this$verticalLayout.g29($markdown);
      $this$verticalLayout.g29(this$0.d1p($options));
      return Unit_instance;
    };
  }
  function MordantHelpFormatter$buildParameterList$lambda($rows, this$0) {
    return function ($this$definitionList) {
      $this$definitionList.v2c_1 = true;
      var _iterator__ex2g4s = $rows.m();
      while (_iterator__ex2g4s.n()) {
        var row = _iterator__ex2g4s.o();
        $this$definitionList.c2d(this$0.y1p(row), this$0.z1p(row));
      }
      return Unit_instance;
    };
  }
  function MordantHelpFormatter(context, requiredOptionMarker, showDefaultValues, showRequiredTag) {
    requiredOptionMarker = requiredOptionMarker === VOID ? null : requiredOptionMarker;
    showDefaultValues = showDefaultValues === VOID ? false : showDefaultValues;
    showRequiredTag = showRequiredTag === VOID ? false : showRequiredTag;
    AbstractHelpFormatter.call(this, context, requiredOptionMarker, showDefaultValues, showRequiredTag);
  }
  protoOf(MordantHelpFormatter).g2e = function () {
    return get_terminal(this.u1m_1).b26_1;
  };
  protoOf(MordantHelpFormatter).t1g = function (error, prolog, epilog, parameters, programName) {
    var widget = verticalLayout(MordantHelpFormatter$formatHelp$lambda(this, error, prolog, epilog, parameters, programName));
    return get_terminal(this.u1m_1).s2c(widget);
  };
  protoOf(MordantHelpFormatter).i1n = function (parameters, error) {
    return Text_init_$Create$(this.m1n(parameters, error));
  };
  protoOf(MordantHelpFormatter).h1n = function (parameters, programName) {
    var title = this.h2e(this.f1n().t1p());
    var prog = title + ' ' + programName;
    var usageParts = this.q1n(parameters);
    var tmp;
    // Inline function 'kotlin.text.isEmpty' call
    if (charSequenceLength(usageParts) === 0) {
      tmp = Text_init_$Create$(prog, Whitespace_NORMAL_getInstance());
    } else {
      tmp = definitionList(MordantHelpFormatter$renderUsage$lambda(prog, usageParts));
    }
    return tmp;
  };
  protoOf(MordantHelpFormatter).j1n = function (prolog) {
    var tmp = this.i2e(prolog);
    return withPadding(tmp, false, MordantHelpFormatter$renderProlog$lambda);
  };
  protoOf(MordantHelpFormatter).l1n = function (epilog) {
    return this.i2e(epilog);
  };
  protoOf(MordantHelpFormatter).k1n = function (parameters) {
    return definitionList(MordantHelpFormatter$renderParameters$lambda(this, parameters));
  };
  protoOf(MordantHelpFormatter).r1o = function (help, parameters) {
    // Inline function 'kotlin.collections.map' call
    // Inline function 'kotlin.collections.mapTo' call
    var destination = ArrayList_init_$Create$(collectionSizeOrDefault(parameters, 10));
    var tmp0_iterator = parameters.m();
    while (tmp0_iterator.n()) {
      var item = tmp0_iterator.o();
      var tmp$ret$0 = this.w1o(item);
      destination.e(tmp$ret$0);
    }
    var options = destination;
    if (help == null)
      return this.d1p(options);
    var tmp = this.i2e(help);
    var markdown = withPadding(tmp, false, MordantHelpFormatter$renderOptionGroup$lambda);
    return verticalLayout(MordantHelpFormatter$renderOptionGroup$lambda_0(markdown, this, options));
  };
  protoOf(MordantHelpFormatter).c1n = function (name) {
    // Inline function 'kotlin.text.lowercase' call
    // Inline function 'kotlin.js.asDynamic' call
    return '<' + name.toLowerCase() + '>';
  };
  protoOf(MordantHelpFormatter).b1p = function (name) {
    return this.g2e().r25('danger').p1y(name);
  };
  protoOf(MordantHelpFormatter).k1p = function (name) {
    return this.g2e().r25('muted').p1y(name);
  };
  protoOf(MordantHelpFormatter).a1n = function (name) {
    return this.g2e().r25('info').p1y(name);
  };
  protoOf(MordantHelpFormatter).d1n = function (name) {
    return this.g2e().r25('info').p1y(name);
  };
  protoOf(MordantHelpFormatter).e1n = function (name) {
    return this.g2e().r25('info').p1y(name);
  };
  protoOf(MordantHelpFormatter).s1o = function (title) {
    return this.g2e().r25('warning').p1y(title);
  };
  protoOf(MordantHelpFormatter).h2e = function (title) {
    return this.g2e().r25('warning').p1y(title);
  };
  protoOf(MordantHelpFormatter).o1n = function (title) {
    return this.g2e().r25('danger').p1y(title);
  };
  protoOf(MordantHelpFormatter).t1n = function (parameter) {
    return this.g2e().r25('muted').p1y(parameter);
  };
  protoOf(MordantHelpFormatter).m1p = function (metavar) {
    return this.g2e().r25('warning').e22(this.g2e().r25('muted')).p1y(metavar);
  };
  protoOf(MordantHelpFormatter).y1p = function (row) {
    var tmp;
    // Inline function 'kotlin.text.isNullOrEmpty' call
    var this_0 = row.r1m_1;
    // Inline function 'kotlin.contracts.contract' call
    if (this_0 == null ? true : charSequenceLength(this_0) === 0) {
      tmp = '  ';
    } else {
      // Inline function 'kotlin.text.ifEmpty' call
      var this_1 = drop('  ', ensureNotNull(row.r1m_1).length);
      // Inline function 'kotlin.contracts.contract' call
      var tmp_0;
      // Inline function 'kotlin.text.isEmpty' call
      if (charSequenceLength(this_1) === 0) {
        // Inline function 'com.github.ajalt.clikt.output.MordantHelpFormatter.renderDefinitionTerm.<anonymous>' call
        tmp_0 = ' ';
      } else {
        tmp_0 = this_1;
      }
      var tmp$ret$3 = tmp_0;
      tmp = plus(row.r1m_1, tmp$ret$3);
    }
    var termPrefix = tmp;
    return Text_init_$Create$(termPrefix + row.p1m_1, Whitespace_PRE_WRAP_getInstance());
  };
  protoOf(MordantHelpFormatter).z1p = function (row) {
    return isBlank(row.q1m_1) ? Text_init_$Create$('') : this.i2e(row.q1m_1);
  };
  protoOf(MordantHelpFormatter).d1p = function (rows) {
    return definitionList(MordantHelpFormatter$buildParameterList$lambda(rows, this));
  };
  protoOf(MordantHelpFormatter).i2e = function (text) {
    return Text_init_$Create$(replace(text, '\n\n', '\x85\x85'), Whitespace_NORMAL_getInstance());
  };
  //region block: exports
  _.$_$ = _.$_$ || {};
  _.$_$.a = CliktCommand;
  //endregion
  return _;
}(module.exports, require('./clikt-clikt.js'), require('./kotlin-kotlin-stdlib.js'), require('./mordant-mordant.js')));

//# sourceMappingURL=clikt-clikt-mordant.js.map
